"use strict";
(self["webpackChunkvariable_inspector"] = self["webpackChunkvariable_inspector"] || []).push([["style_index_js"],{

/***/ "./node_modules/css-loader/dist/runtime/api.js":
/*!*****************************************************!*\
  !*** ./node_modules/css-loader/dist/runtime/api.js ***!
  \*****************************************************/
/***/ ((module) => {



/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
*/
module.exports = function (cssWithMappingToString) {
  var list = [];

  // return the list of modules as css string
  list.toString = function toString() {
    return this.map(function (item) {
      var content = "";
      var needLayer = typeof item[5] !== "undefined";
      if (item[4]) {
        content += "@supports (".concat(item[4], ") {");
      }
      if (item[2]) {
        content += "@media ".concat(item[2], " {");
      }
      if (needLayer) {
        content += "@layer".concat(item[5].length > 0 ? " ".concat(item[5]) : "", " {");
      }
      content += cssWithMappingToString(item);
      if (needLayer) {
        content += "}";
      }
      if (item[2]) {
        content += "}";
      }
      if (item[4]) {
        content += "}";
      }
      return content;
    }).join("");
  };

  // import a list of modules into the list
  list.i = function i(modules, media, dedupe, supports, layer) {
    if (typeof modules === "string") {
      modules = [[null, modules, undefined]];
    }
    var alreadyImportedModules = {};
    if (dedupe) {
      for (var k = 0; k < this.length; k++) {
        var id = this[k][0];
        if (id != null) {
          alreadyImportedModules[id] = true;
        }
      }
    }
    for (var _k = 0; _k < modules.length; _k++) {
      var item = [].concat(modules[_k]);
      if (dedupe && alreadyImportedModules[item[0]]) {
        continue;
      }
      if (typeof layer !== "undefined") {
        if (typeof item[5] === "undefined") {
          item[5] = layer;
        } else {
          item[1] = "@layer".concat(item[5].length > 0 ? " ".concat(item[5]) : "", " {").concat(item[1], "}");
          item[5] = layer;
        }
      }
      if (media) {
        if (!item[2]) {
          item[2] = media;
        } else {
          item[1] = "@media ".concat(item[2], " {").concat(item[1], "}");
          item[2] = media;
        }
      }
      if (supports) {
        if (!item[4]) {
          item[4] = "".concat(supports);
        } else {
          item[1] = "@supports (".concat(item[4], ") {").concat(item[1], "}");
          item[4] = supports;
        }
      }
      list.push(item);
    }
  };
  return list;
};

/***/ }),

/***/ "./node_modules/css-loader/dist/runtime/sourceMaps.js":
/*!************************************************************!*\
  !*** ./node_modules/css-loader/dist/runtime/sourceMaps.js ***!
  \************************************************************/
/***/ ((module) => {



module.exports = function (item) {
  var content = item[1];
  var cssMapping = item[3];
  if (!cssMapping) {
    return content;
  }
  if (typeof btoa === "function") {
    var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(cssMapping))));
    var data = "sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(base64);
    var sourceMapping = "/*# ".concat(data, " */");
    return [content].concat([sourceMapping]).join("\n");
  }
  return [content].join("\n");
};

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js":
/*!****************************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js ***!
  \****************************************************************************/
/***/ ((module) => {



var stylesInDOM = [];
function getIndexByIdentifier(identifier) {
  var result = -1;
  for (var i = 0; i < stylesInDOM.length; i++) {
    if (stylesInDOM[i].identifier === identifier) {
      result = i;
      break;
    }
  }
  return result;
}
function modulesToDom(list, options) {
  var idCountMap = {};
  var identifiers = [];
  for (var i = 0; i < list.length; i++) {
    var item = list[i];
    var id = options.base ? item[0] + options.base : item[0];
    var count = idCountMap[id] || 0;
    var identifier = "".concat(id, " ").concat(count);
    idCountMap[id] = count + 1;
    var indexByIdentifier = getIndexByIdentifier(identifier);
    var obj = {
      css: item[1],
      media: item[2],
      sourceMap: item[3],
      supports: item[4],
      layer: item[5]
    };
    if (indexByIdentifier !== -1) {
      stylesInDOM[indexByIdentifier].references++;
      stylesInDOM[indexByIdentifier].updater(obj);
    } else {
      var updater = addElementStyle(obj, options);
      options.byIndex = i;
      stylesInDOM.splice(i, 0, {
        identifier: identifier,
        updater: updater,
        references: 1
      });
    }
    identifiers.push(identifier);
  }
  return identifiers;
}
function addElementStyle(obj, options) {
  var api = options.domAPI(options);
  api.update(obj);
  var updater = function updater(newObj) {
    if (newObj) {
      if (newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap && newObj.supports === obj.supports && newObj.layer === obj.layer) {
        return;
      }
      api.update(obj = newObj);
    } else {
      api.remove();
    }
  };
  return updater;
}
module.exports = function (list, options) {
  options = options || {};
  list = list || [];
  var lastIdentifiers = modulesToDom(list, options);
  return function update(newList) {
    newList = newList || [];
    for (var i = 0; i < lastIdentifiers.length; i++) {
      var identifier = lastIdentifiers[i];
      var index = getIndexByIdentifier(identifier);
      stylesInDOM[index].references--;
    }
    var newLastIdentifiers = modulesToDom(newList, options);
    for (var _i = 0; _i < lastIdentifiers.length; _i++) {
      var _identifier = lastIdentifiers[_i];
      var _index = getIndexByIdentifier(_identifier);
      if (stylesInDOM[_index].references === 0) {
        stylesInDOM[_index].updater();
        stylesInDOM.splice(_index, 1);
      }
    }
    lastIdentifiers = newLastIdentifiers;
  };
};

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/insertBySelector.js":
/*!********************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/insertBySelector.js ***!
  \********************************************************************/
/***/ ((module) => {



var memo = {};

/* istanbul ignore next  */
function getTarget(target) {
  if (typeof memo[target] === "undefined") {
    var styleTarget = document.querySelector(target);

    // Special case to return head of iframe instead of iframe itself
    if (window.HTMLIFrameElement && styleTarget instanceof window.HTMLIFrameElement) {
      try {
        // This will throw an exception if access to iframe is blocked
        // due to cross-origin restrictions
        styleTarget = styleTarget.contentDocument.head;
      } catch (e) {
        // istanbul ignore next
        styleTarget = null;
      }
    }
    memo[target] = styleTarget;
  }
  return memo[target];
}

/* istanbul ignore next  */
function insertBySelector(insert, style) {
  var target = getTarget(insert);
  if (!target) {
    throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");
  }
  target.appendChild(style);
}
module.exports = insertBySelector;

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/insertStyleElement.js":
/*!**********************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/insertStyleElement.js ***!
  \**********************************************************************/
/***/ ((module) => {



/* istanbul ignore next  */
function insertStyleElement(options) {
  var element = document.createElement("style");
  options.setAttributes(element, options.attributes);
  options.insert(element, options.options);
  return element;
}
module.exports = insertStyleElement;

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/setAttributesWithoutAttributes.js":
/*!**********************************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/setAttributesWithoutAttributes.js ***!
  \**********************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



/* istanbul ignore next  */
function setAttributesWithoutAttributes(styleElement) {
  var nonce =  true ? __webpack_require__.nc : 0;
  if (nonce) {
    styleElement.setAttribute("nonce", nonce);
  }
}
module.exports = setAttributesWithoutAttributes;

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/styleDomAPI.js":
/*!***************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/styleDomAPI.js ***!
  \***************************************************************/
/***/ ((module) => {



/* istanbul ignore next  */
function apply(styleElement, options, obj) {
  var css = "";
  if (obj.supports) {
    css += "@supports (".concat(obj.supports, ") {");
  }
  if (obj.media) {
    css += "@media ".concat(obj.media, " {");
  }
  var needLayer = typeof obj.layer !== "undefined";
  if (needLayer) {
    css += "@layer".concat(obj.layer.length > 0 ? " ".concat(obj.layer) : "", " {");
  }
  css += obj.css;
  if (needLayer) {
    css += "}";
  }
  if (obj.media) {
    css += "}";
  }
  if (obj.supports) {
    css += "}";
  }
  var sourceMap = obj.sourceMap;
  if (sourceMap && typeof btoa !== "undefined") {
    css += "\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))), " */");
  }

  // For old IE
  /* istanbul ignore if  */
  options.styleTagTransform(css, styleElement, options.options);
}
function removeStyleElement(styleElement) {
  // istanbul ignore if
  if (styleElement.parentNode === null) {
    return false;
  }
  styleElement.parentNode.removeChild(styleElement);
}

/* istanbul ignore next  */
function domAPI(options) {
  if (typeof document === "undefined") {
    return {
      update: function update() {},
      remove: function remove() {}
    };
  }
  var styleElement = options.insertStyleElement(options);
  return {
    update: function update(obj) {
      apply(styleElement, options, obj);
    },
    remove: function remove() {
      removeStyleElement(styleElement);
    }
  };
}
module.exports = domAPI;

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/styleTagTransform.js":
/*!*********************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/styleTagTransform.js ***!
  \*********************************************************************/
/***/ ((module) => {



/* istanbul ignore next  */
function styleTagTransform(css, styleElement) {
  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = css;
  } else {
    while (styleElement.firstChild) {
      styleElement.removeChild(styleElement.firstChild);
    }
    styleElement.appendChild(document.createTextNode(css));
  }
}
module.exports = styleTagTransform;

/***/ }),

/***/ "./style/index.js":
/*!************************!*\
  !*** ./style/index.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _base_css__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base.css */ "./style/base.css");



/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js!./style/base.css":
/*!**************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js!./style/base.css ***!
  \**************************************************************/
/***/ ((module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _node_modules_css_loader_dist_runtime_sourceMaps_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/css-loader/dist/runtime/sourceMaps.js */ "./node_modules/css-loader/dist/runtime/sourceMaps.js");
/* harmony import */ var _node_modules_css_loader_dist_runtime_sourceMaps_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_css_loader_dist_runtime_sourceMaps_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/css-loader/dist/runtime/api.js */ "./node_modules/css-loader/dist/runtime/api.js");
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_1__);
// Imports


var ___CSS_LOADER_EXPORT___ = _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_1___default()((_node_modules_css_loader_dist_runtime_sourceMaps_js__WEBPACK_IMPORTED_MODULE_0___default()));
// Module
___CSS_LOADER_EXPORT___.push([module.id, `.mljar-variable-inspector-sidebar-widget {
  background-color: #ffffff;
  padding: 10px;
  font-family: 'Courier New', Courier, monospace;
}

.mljar-variable-inspector-sidebar-container {
  display: flex;
  flex-direction: column;
  height: 100%;
  overflow-y: auto;
}

.mljar-variable-inspector-list-container {
  flex: 1;
  overflow-y: hidden;
  padding-right: 10px;
}

.mljar-variable-inspector-list-container::-webkit-scrollbar {
  width: 8px;
}

.mljar-variable-inspector-list-container::-webkit-scrollbar-thumb {
  background-color: rgba(0, 0, 0, 0.2);
  border-radius: 4px;
}

.mljar-variable-inspector-list-container::-webkit-scrollbar-track {
  background-color: rgba(0, 0, 0, 0.05);
}

.mljar-variable-inspector-container {
  display: flex;
  flex-direction: column;
  height: 100%;
}

.mljar-variable-header-container {
  display: flex;
  justify-content: space-between;
  align-items: flex-end;
  margin-bottom: 8px;
  margin-right: 8px;
  border-bottom: 2px solid #ddd;
}

.mljar-variable-header {
  flex: 4;
  font-size: 0.85rem;
  font-weight: 700;
  color: var(--jp-ui-font-color1);
  text-align: left;
  padding-bottom: 8px;
  margin: 0;
}

.mljar-variable-inspector-header-list {
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(0, 1fr));
  align-items: center;
  font-size: 0.85rem;
  column-gap: 1rem;
  padding: 10px 8px;
  background-color: var(--jp-layout-color0);
  color: #0099cc;
  border: 1px solid #0099cc;
  border-top-right-radius: 5px;
  border-top-left-radius: 5px;
  font-weight: 800;
}

.mljar-variable-inspector-item {
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(0, 1fr));
  align-items: center;
  column-gap: 1rem;
  padding-left: 8px;
  padding-right: 8px;
  border-bottom: 1px solid var(--jp-border-color2);
  border-left: 1px solid var(--jp-border-color2);
  border-right: 1px solid var(--jp-border-color2);
  margin-bottom: 0px;
  margin-right: 0px;
  width: 100%;
  box-sizing: border-box;
  background-color: var(--jp-layout-color0);
  font-size: 0.7rem;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
}

.mljar-variable-inspector-item.small-value {
  min-height: 39px;
}

.mljar-variable-inspector-show-variable-button {
  background: none;
  position: relative;
  border: none;
  border-radius: 4px;
  cursor: pointer;
  padding: 4px;
  margin: 5px 0px;
  display: inline-block;
  width: 28px;
  align-items: center;
  justify-content: flex-start;
  color: #0099cc;
  transition: background-color 0.3s ease;
}

.mljar-variable-inspector-show-variable-button:disabled {
  opacity: 0.5;
  cursor: not-allowed;
}

.mljar-variable-inspector-list {
  list-style: none;
  padding: 0;
  margin: 0;
}

.mljar-variable-search-bar-container {
  margin: 0px 10px 10px 0px;
}

.mljar-variable-inspector-search-bar-input {
  width: 100%;
  padding: 8px;
  box-sizing: border-box;
  background-color: var(--jp-layout-color1);
  color: var(--jp-ui-font-color1);
  border: 1px solid var(--jp-border-color2);
  border-radius: 5px;
}

.mljar-variable-inspector-search-bar-input:focus {
  outline: none;
  border: 2px solid var(--jp-ui-font-color1);
}

.mljar-variable-inspector-search-bar-input::placeholder {
  color: var(--jp-ui-font-color2);
}

.mljar-variable-inspector-variable-name {
  font-weight: 600;
}

.mljar-variable-inspector-item:hover {
  background-color: var(--jp-layout-color2);
  cursor: pointer;
}

.mljar-variable-inspector-item.active {
  background-color: var(--jp-brand-color1);
  color: var(--jp-ui-inverse-font-color1);
}

.mljar-varable-item.active {
  background-color: var(--jp-brand-color1);
  color: var(--jp-ui-inverse-font-color1);
}

.mljar-variable-inspector-variable-name,
.mljar-variable-type,
.mljar-variable-inspector-variable-size,
.mljar-variable-inspector-variable-value,
.mljar-variable-shape {
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

.mljar-variable-inspector-variable-size {
  word-spacing: -5px;
}

.mljar-variable-inspector-show-variable-button:hover {
  color: #fff;
  background-color: #0099cc;
  transition: background-color 0.3s ease;
}

.mljar-variable-detail-button-icon {
  display: flex;
  align-items: center;
  width: 20px;
  height: 20px;
}

.mljar-variable-inspector-settings-button,
.mljar-variable-inspector-refresh-button {
  width: 30px;
  display: flex;
  margin: 2px 1px;
  align-items: center;
  justify-content: center;
  gap: 8px;
  color: #0099cc;
  border: none;
  border-radius: 4px;
  padding: 8px 0px;
  cursor: pointer;
  font-size: 0.75rem;
  transition: background-color 0.3s ease;
}
.mljar-variable-inspector-settings-button:disabled,
.mljar-variable-inspector-refresh-button:disabled {
  cursor: not-allowed;
}
.mljar-variable-inspector-settings-button:hover:not(:disabled),
.mljar-variable-inspector-refresh-button:hover:not(:disabled) {
  background-color: #0099cc;
  color: #ffffff;
}

.mljar-variable-inspector-refresh-button.manually-refresh {
  color: #28a745;
}

.mljar-variable-inspector-refresh-button.manually-refresh:hover:not(:disabled) {
  background-color: #28a745;
  color: #ffffff;
}

.mljar-variable-inspector-settings-button.active {
  background-color: #0099cc;
  color: #ffffff;
}
.mljar-variable-inspector-settings-icon,
.mljar-variable-inspector-refresh-icon {
  display: flex;
  align-items: center;
  width: 15px;
  height: 15px;
}

.mljar-variable-inspector-message {
  margin: 10px 0px 0px 5px;
  font-size: small;
}

.mljar-variable-inspector-settings-container {
  position: relative;
  display: inline-block;
}

.mljar-variable-inspector-settings-menu {
  position: absolute;
  right: 0;
  top: 40px;
  width: 200px;
  background-color: var(--jp-layout-color0);
  border: 1px solid var(--jp-layout-color3);
  box-shadow: 0px 2px 24px 0px var(--jp-layout-color2);
  border-radius: 5px;
  z-index: 100;
}

.mljar-variable-inspector-settings-menu-list {
  list-style: none;
  margin: 0px;
  padding: 0px;
}

.mljar-variable-inspector-settings-menu-item {
  font-size: 12px;
  padding: 5px 10px;
  cursor: pointer;
  text-align: left;
  width: 100%;
  transition: background 0.3s ease;
  display: flex;
  justify-content: space-between;
  align-items: center;
}

.mljar-variable-inspector-settings-menu-item.first {
  border-top-left-radius: 5px;
  border-top-right-radius: 5px;
}

.mljar-variable-inspector-settings-menu-item.last {
  border-bottom-left-radius: 5px;
  border-bottom-right-radius: 5px;
}

.mljar-variable-inspector-settings-menu-item:hover {
  background-color: var(--jp-layout-color2);
  cursor: pointer;
}

.mljar-variable-actions-container {
  display: flex;
  gap: 10px;
  margin-bottom: 10px;
  margin-right: 10px;
}

.mljar-variable-inspector-sidebar-container::-webkit-scrollbar {
  width: 9px;
  height: 8px;
}

.mljar-variable-inspector-sidebar-container::-webkit-scrollbar-track {
  background: var(--jp-layout-color3);
  border-radius: 8px;
}

.mljar-variable-inspector-sidebar-container::-webkit-scrollbar-thumb {
  background-color: rgba(255, 255, 255, 0.6);
  border-radius: 8px;
  border: 2px solid transparent;
  background-clip: padding-box;
}

.mljar-variable-spinner {
  border: 4px solid rgba(0, 0, 0, 0.1);
  width: 10px;
  height: 10px;
  border-radius: 50%;
  border-left-color: #ffffff;
  animation: spin 1s linear infinite;
}

.mljar-variable-spinner-big {
  border: 4px solid rgba(0, 0, 0, 0.1);
  width: 20px;
  height: 20px;
  border-radius: 50%;
  border-left-color: #ffffff;
  animation: spin 1s linear infinite;
}

@keyframes spin {
  to {
    transform: rotate(360deg);
  }
}
`, "",{"version":3,"sources":["webpack://./style/base.css"],"names":[],"mappings":"AAAA;EACE,yBAAyB;EACzB,aAAa;EACb,8CAA8C;AAChD;;AAEA;EACE,aAAa;EACb,sBAAsB;EACtB,YAAY;EACZ,gBAAgB;AAClB;;AAEA;EACE,OAAO;EACP,kBAAkB;EAClB,mBAAmB;AACrB;;AAEA;EACE,UAAU;AACZ;;AAEA;EACE,oCAAoC;EACpC,kBAAkB;AACpB;;AAEA;EACE,qCAAqC;AACvC;;AAEA;EACE,aAAa;EACb,sBAAsB;EACtB,YAAY;AACd;;AAEA;EACE,aAAa;EACb,8BAA8B;EAC9B,qBAAqB;EACrB,kBAAkB;EAClB,iBAAiB;EACjB,6BAA6B;AAC/B;;AAEA;EACE,OAAO;EACP,kBAAkB;EAClB,gBAAgB;EAChB,+BAA+B;EAC/B,gBAAgB;EAChB,mBAAmB;EACnB,SAAS;AACX;;AAEA;EACE,aAAa;EACb,uDAAuD;EACvD,mBAAmB;EACnB,kBAAkB;EAClB,gBAAgB;EAChB,iBAAiB;EACjB,yCAAyC;EACzC,cAAc;EACd,yBAAyB;EACzB,4BAA4B;EAC5B,2BAA2B;EAC3B,gBAAgB;AAClB;;AAEA;EACE,aAAa;EACb,uDAAuD;EACvD,mBAAmB;EACnB,gBAAgB;EAChB,iBAAiB;EACjB,kBAAkB;EAClB,gDAAgD;EAChD,8CAA8C;EAC9C,+CAA+C;EAC/C,kBAAkB;EAClB,iBAAiB;EACjB,WAAW;EACX,sBAAsB;EACtB,yCAAyC;EACzC,iBAAiB;EACjB,wCAAwC;AAC1C;;AAEA;EACE,gBAAgB;AAClB;;AAEA;EACE,gBAAgB;EAChB,kBAAkB;EAClB,YAAY;EACZ,kBAAkB;EAClB,eAAe;EACf,YAAY;EACZ,eAAe;EACf,qBAAqB;EACrB,WAAW;EACX,mBAAmB;EACnB,2BAA2B;EAC3B,cAAc;EACd,sCAAsC;AACxC;;AAEA;EACE,YAAY;EACZ,mBAAmB;AACrB;;AAEA;EACE,gBAAgB;EAChB,UAAU;EACV,SAAS;AACX;;AAEA;EACE,yBAAyB;AAC3B;;AAEA;EACE,WAAW;EACX,YAAY;EACZ,sBAAsB;EACtB,yCAAyC;EACzC,+BAA+B;EAC/B,yCAAyC;EACzC,kBAAkB;AACpB;;AAEA;EACE,aAAa;EACb,0CAA0C;AAC5C;;AAEA;EACE,+BAA+B;AACjC;;AAEA;EACE,gBAAgB;AAClB;;AAEA;EACE,yCAAyC;EACzC,eAAe;AACjB;;AAEA;EACE,wCAAwC;EACxC,uCAAuC;AACzC;;AAEA;EACE,wCAAwC;EACxC,uCAAuC;AACzC;;AAEA;;;;;EAKE,gBAAgB;EAChB,uBAAuB;EACvB,mBAAmB;AACrB;;AAEA;EACE,kBAAkB;AACpB;;AAEA;EACE,WAAW;EACX,yBAAyB;EACzB,sCAAsC;AACxC;;AAEA;EACE,aAAa;EACb,mBAAmB;EACnB,WAAW;EACX,YAAY;AACd;;AAEA;;EAEE,WAAW;EACX,aAAa;EACb,eAAe;EACf,mBAAmB;EACnB,uBAAuB;EACvB,QAAQ;EACR,cAAc;EACd,YAAY;EACZ,kBAAkB;EAClB,gBAAgB;EAChB,eAAe;EACf,kBAAkB;EAClB,sCAAsC;AACxC;AACA;;EAEE,mBAAmB;AACrB;AACA;;EAEE,yBAAyB;EACzB,cAAc;AAChB;;AAEA;EACE,cAAc;AAChB;;AAEA;EACE,yBAAyB;EACzB,cAAc;AAChB;;AAEA;EACE,yBAAyB;EACzB,cAAc;AAChB;AACA;;EAEE,aAAa;EACb,mBAAmB;EACnB,WAAW;EACX,YAAY;AACd;;AAEA;EACE,wBAAwB;EACxB,gBAAgB;AAClB;;AAEA;EACE,kBAAkB;EAClB,qBAAqB;AACvB;;AAEA;EACE,kBAAkB;EAClB,QAAQ;EACR,SAAS;EACT,YAAY;EACZ,yCAAyC;EACzC,yCAAyC;EACzC,oDAAoD;EACpD,kBAAkB;EAClB,YAAY;AACd;;AAEA;EACE,gBAAgB;EAChB,WAAW;EACX,YAAY;AACd;;AAEA;EACE,eAAe;EACf,iBAAiB;EACjB,eAAe;EACf,gBAAgB;EAChB,WAAW;EACX,gCAAgC;EAChC,aAAa;EACb,8BAA8B;EAC9B,mBAAmB;AACrB;;AAEA;EACE,2BAA2B;EAC3B,4BAA4B;AAC9B;;AAEA;EACE,8BAA8B;EAC9B,+BAA+B;AACjC;;AAEA;EACE,yCAAyC;EACzC,eAAe;AACjB;;AAEA;EACE,aAAa;EACb,SAAS;EACT,mBAAmB;EACnB,kBAAkB;AACpB;;AAEA;EACE,UAAU;EACV,WAAW;AACb;;AAEA;EACE,mCAAmC;EACnC,kBAAkB;AACpB;;AAEA;EACE,0CAA0C;EAC1C,kBAAkB;EAClB,6BAA6B;EAC7B,4BAA4B;AAC9B;;AAEA;EACE,oCAAoC;EACpC,WAAW;EACX,YAAY;EACZ,kBAAkB;EAClB,0BAA0B;EAC1B,kCAAkC;AACpC;;AAEA;EACE,oCAAoC;EACpC,WAAW;EACX,YAAY;EACZ,kBAAkB;EAClB,0BAA0B;EAC1B,kCAAkC;AACpC;;AAEA;EACE;IACE,yBAAyB;EAC3B;AACF","sourcesContent":[".mljar-variable-inspector-sidebar-widget {\n  background-color: #ffffff;\n  padding: 10px;\n  font-family: 'Courier New', Courier, monospace;\n}\n\n.mljar-variable-inspector-sidebar-container {\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  overflow-y: auto;\n}\n\n.mljar-variable-inspector-list-container {\n  flex: 1;\n  overflow-y: hidden;\n  padding-right: 10px;\n}\n\n.mljar-variable-inspector-list-container::-webkit-scrollbar {\n  width: 8px;\n}\n\n.mljar-variable-inspector-list-container::-webkit-scrollbar-thumb {\n  background-color: rgba(0, 0, 0, 0.2);\n  border-radius: 4px;\n}\n\n.mljar-variable-inspector-list-container::-webkit-scrollbar-track {\n  background-color: rgba(0, 0, 0, 0.05);\n}\n\n.mljar-variable-inspector-container {\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n}\n\n.mljar-variable-header-container {\n  display: flex;\n  justify-content: space-between;\n  align-items: flex-end;\n  margin-bottom: 8px;\n  margin-right: 8px;\n  border-bottom: 2px solid #ddd;\n}\n\n.mljar-variable-header {\n  flex: 4;\n  font-size: 0.85rem;\n  font-weight: 700;\n  color: var(--jp-ui-font-color1);\n  text-align: left;\n  padding-bottom: 8px;\n  margin: 0;\n}\n\n.mljar-variable-inspector-header-list {\n  display: grid;\n  grid-template-columns: repeat(auto-fit, minmax(0, 1fr));\n  align-items: center;\n  font-size: 0.85rem;\n  column-gap: 1rem;\n  padding: 10px 8px;\n  background-color: var(--jp-layout-color0);\n  color: #0099cc;\n  border: 1px solid #0099cc;\n  border-top-right-radius: 5px;\n  border-top-left-radius: 5px;\n  font-weight: 800;\n}\n\n.mljar-variable-inspector-item {\n  display: grid;\n  grid-template-columns: repeat(auto-fit, minmax(0, 1fr));\n  align-items: center;\n  column-gap: 1rem;\n  padding-left: 8px;\n  padding-right: 8px;\n  border-bottom: 1px solid var(--jp-border-color2);\n  border-left: 1px solid var(--jp-border-color2);\n  border-right: 1px solid var(--jp-border-color2);\n  margin-bottom: 0px;\n  margin-right: 0px;\n  width: 100%;\n  box-sizing: border-box;\n  background-color: var(--jp-layout-color0);\n  font-size: 0.7rem;\n  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);\n}\n\n.mljar-variable-inspector-item.small-value {\n  min-height: 39px;\n}\n\n.mljar-variable-inspector-show-variable-button {\n  background: none;\n  position: relative;\n  border: none;\n  border-radius: 4px;\n  cursor: pointer;\n  padding: 4px;\n  margin: 5px 0px;\n  display: inline-block;\n  width: 28px;\n  align-items: center;\n  justify-content: flex-start;\n  color: #0099cc;\n  transition: background-color 0.3s ease;\n}\n\n.mljar-variable-inspector-show-variable-button:disabled {\n  opacity: 0.5;\n  cursor: not-allowed;\n}\n\n.mljar-variable-inspector-list {\n  list-style: none;\n  padding: 0;\n  margin: 0;\n}\n\n.mljar-variable-search-bar-container {\n  margin: 0px 10px 10px 0px;\n}\n\n.mljar-variable-inspector-search-bar-input {\n  width: 100%;\n  padding: 8px;\n  box-sizing: border-box;\n  background-color: var(--jp-layout-color1);\n  color: var(--jp-ui-font-color1);\n  border: 1px solid var(--jp-border-color2);\n  border-radius: 5px;\n}\n\n.mljar-variable-inspector-search-bar-input:focus {\n  outline: none;\n  border: 2px solid var(--jp-ui-font-color1);\n}\n\n.mljar-variable-inspector-search-bar-input::placeholder {\n  color: var(--jp-ui-font-color2);\n}\n\n.mljar-variable-inspector-variable-name {\n  font-weight: 600;\n}\n\n.mljar-variable-inspector-item:hover {\n  background-color: var(--jp-layout-color2);\n  cursor: pointer;\n}\n\n.mljar-variable-inspector-item.active {\n  background-color: var(--jp-brand-color1);\n  color: var(--jp-ui-inverse-font-color1);\n}\n\n.mljar-varable-item.active {\n  background-color: var(--jp-brand-color1);\n  color: var(--jp-ui-inverse-font-color1);\n}\n\n.mljar-variable-inspector-variable-name,\n.mljar-variable-type,\n.mljar-variable-inspector-variable-size,\n.mljar-variable-inspector-variable-value,\n.mljar-variable-shape {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.mljar-variable-inspector-variable-size {\n  word-spacing: -5px;\n}\n\n.mljar-variable-inspector-show-variable-button:hover {\n  color: #fff;\n  background-color: #0099cc;\n  transition: background-color 0.3s ease;\n}\n\n.mljar-variable-detail-button-icon {\n  display: flex;\n  align-items: center;\n  width: 20px;\n  height: 20px;\n}\n\n.mljar-variable-inspector-settings-button,\n.mljar-variable-inspector-refresh-button {\n  width: 30px;\n  display: flex;\n  margin: 2px 1px;\n  align-items: center;\n  justify-content: center;\n  gap: 8px;\n  color: #0099cc;\n  border: none;\n  border-radius: 4px;\n  padding: 8px 0px;\n  cursor: pointer;\n  font-size: 0.75rem;\n  transition: background-color 0.3s ease;\n}\n.mljar-variable-inspector-settings-button:disabled,\n.mljar-variable-inspector-refresh-button:disabled {\n  cursor: not-allowed;\n}\n.mljar-variable-inspector-settings-button:hover:not(:disabled),\n.mljar-variable-inspector-refresh-button:hover:not(:disabled) {\n  background-color: #0099cc;\n  color: #ffffff;\n}\n\n.mljar-variable-inspector-refresh-button.manually-refresh {\n  color: #28a745;\n}\n\n.mljar-variable-inspector-refresh-button.manually-refresh:hover:not(:disabled) {\n  background-color: #28a745;\n  color: #ffffff;\n}\n\n.mljar-variable-inspector-settings-button.active {\n  background-color: #0099cc;\n  color: #ffffff;\n}\n.mljar-variable-inspector-settings-icon,\n.mljar-variable-inspector-refresh-icon {\n  display: flex;\n  align-items: center;\n  width: 15px;\n  height: 15px;\n}\n\n.mljar-variable-inspector-message {\n  margin: 10px 0px 0px 5px;\n  font-size: small;\n}\n\n.mljar-variable-inspector-settings-container {\n  position: relative;\n  display: inline-block;\n}\n\n.mljar-variable-inspector-settings-menu {\n  position: absolute;\n  right: 0;\n  top: 40px;\n  width: 200px;\n  background-color: var(--jp-layout-color0);\n  border: 1px solid var(--jp-layout-color3);\n  box-shadow: 0px 2px 24px 0px var(--jp-layout-color2);\n  border-radius: 5px;\n  z-index: 100;\n}\n\n.mljar-variable-inspector-settings-menu-list {\n  list-style: none;\n  margin: 0px;\n  padding: 0px;\n}\n\n.mljar-variable-inspector-settings-menu-item {\n  font-size: 12px;\n  padding: 5px 10px;\n  cursor: pointer;\n  text-align: left;\n  width: 100%;\n  transition: background 0.3s ease;\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n}\n\n.mljar-variable-inspector-settings-menu-item.first {\n  border-top-left-radius: 5px;\n  border-top-right-radius: 5px;\n}\n\n.mljar-variable-inspector-settings-menu-item.last {\n  border-bottom-left-radius: 5px;\n  border-bottom-right-radius: 5px;\n}\n\n.mljar-variable-inspector-settings-menu-item:hover {\n  background-color: var(--jp-layout-color2);\n  cursor: pointer;\n}\n\n.mljar-variable-actions-container {\n  display: flex;\n  gap: 10px;\n  margin-bottom: 10px;\n  margin-right: 10px;\n}\n\n.mljar-variable-inspector-sidebar-container::-webkit-scrollbar {\n  width: 9px;\n  height: 8px;\n}\n\n.mljar-variable-inspector-sidebar-container::-webkit-scrollbar-track {\n  background: var(--jp-layout-color3);\n  border-radius: 8px;\n}\n\n.mljar-variable-inspector-sidebar-container::-webkit-scrollbar-thumb {\n  background-color: rgba(255, 255, 255, 0.6);\n  border-radius: 8px;\n  border: 2px solid transparent;\n  background-clip: padding-box;\n}\n\n.mljar-variable-spinner {\n  border: 4px solid rgba(0, 0, 0, 0.1);\n  width: 10px;\n  height: 10px;\n  border-radius: 50%;\n  border-left-color: #ffffff;\n  animation: spin 1s linear infinite;\n}\n\n.mljar-variable-spinner-big {\n  border: 4px solid rgba(0, 0, 0, 0.1);\n  width: 20px;\n  height: 20px;\n  border-radius: 50%;\n  border-left-color: #ffffff;\n  animation: spin 1s linear infinite;\n}\n\n@keyframes spin {\n  to {\n    transform: rotate(360deg);\n  }\n}\n"],"sourceRoot":""}]);
// Exports
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (___CSS_LOADER_EXPORT___);


/***/ }),

/***/ "./style/base.css":
/*!************************!*\
  !*** ./style/base.css ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js */ "./node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_styleDomAPI_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/styleDomAPI.js */ "./node_modules/style-loader/dist/runtime/styleDomAPI.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_styleDomAPI_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_styleDomAPI_js__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_insertBySelector_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/insertBySelector.js */ "./node_modules/style-loader/dist/runtime/insertBySelector.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_insertBySelector_js__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_insertBySelector_js__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_setAttributesWithoutAttributes_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/setAttributesWithoutAttributes.js */ "./node_modules/style-loader/dist/runtime/setAttributesWithoutAttributes.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_setAttributesWithoutAttributes_js__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_setAttributesWithoutAttributes_js__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_insertStyleElement_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/insertStyleElement.js */ "./node_modules/style-loader/dist/runtime/insertStyleElement.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_insertStyleElement_js__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_insertStyleElement_js__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_styleTagTransform_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/styleTagTransform.js */ "./node_modules/style-loader/dist/runtime/styleTagTransform.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_styleTagTransform_js__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_styleTagTransform_js__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! !!../node_modules/css-loader/dist/cjs.js!./base.css */ "./node_modules/css-loader/dist/cjs.js!./style/base.css");

      
      
      
      
      
      
      
      
      

var options = {};

options.styleTagTransform = (_node_modules_style_loader_dist_runtime_styleTagTransform_js__WEBPACK_IMPORTED_MODULE_5___default());
options.setAttributes = (_node_modules_style_loader_dist_runtime_setAttributesWithoutAttributes_js__WEBPACK_IMPORTED_MODULE_3___default());

      options.insert = _node_modules_style_loader_dist_runtime_insertBySelector_js__WEBPACK_IMPORTED_MODULE_2___default().bind(null, "head");
    
options.domAPI = (_node_modules_style_loader_dist_runtime_styleDomAPI_js__WEBPACK_IMPORTED_MODULE_1___default());
options.insertStyleElement = (_node_modules_style_loader_dist_runtime_insertStyleElement_js__WEBPACK_IMPORTED_MODULE_4___default());

var update = _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0___default()(_node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__["default"], options);




       /* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (_node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__["default"] && _node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__["default"].locals ? _node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__["default"].locals : undefined);


/***/ })

}]);
//# sourceMappingURL=style_index_js.bd199a6d0fd20c3c0b09.js.map